searchData={"items":[{"type":"module","title":"Islands.Game","doc":"A game struct and functions for the _Game of Islands_.\n\nThe game struct contains the fields `name`, `player1`, `player2`, `request`,\n`response` and `state` representing the properties of a game in the _Game of\nIslands_.\n\n##### Based on the book [Functional Web Development](https://pragprog.com/titles/lhelph/functional-web-development-with-elixir-otp-and-phoenix/) by Lance Halvorsen.","ref":"Islands.Game.html"},{"type":"function","title":"Islands.Game.fetch/2","doc":"Callback implementation for  Access.fetch/2 .","ref":"Islands.Game.html#fetch/2"},{"type":"function","title":"Islands.Game.get_and_update/3","doc":"Callback implementation for  Access.get_and_update/3 .","ref":"Islands.Game.html#get_and_update/3"},{"type":"function","title":"Islands.Game.haiku_name/0","doc":"Returns a unique, URL-friendly name such as \"bold-frog-8249\".","ref":"Islands.Game.html#haiku_name/0"},{"type":"type","title":"Islands.Game.name/0","doc":"Game name","ref":"Islands.Game.html#t:name/0"},{"type":"function","title":"Islands.Game.new/4","doc":"Creates a game struct from `name`, `player1_name`, `gender` and `pid`.","ref":"Islands.Game.html#new/4"},{"type":"function","title":"Examples - Islands.Game.new/4","doc":"iex> alias Islands.{Game, Player}\n    iex> {player_name, gender, pid} = {\"James\", :m, self()}\n    iex> game = Game.new(\"Sky Fall\", player_name, gender, pid)\n    iex> %Game{name: name, player1: player1} = game\n    iex> %Player{name: ^player_name, gender: ^gender, pid: ^pid} = player1\n    iex> {name, is_struct(player1, Player), is_struct(game.player2, Player)}\n    {\"Sky Fall\", true, true}\n\n    iex> alias Islands.Game\n    iex> {player_name, gender, pid} = {\"James\", :m, self()}\n    iex> Game.new(~c'Sky Fall', player_name, gender, pid)\n    {:error, :invalid_game_args}","ref":"Islands.Game.html#new/4-examples"},{"type":"function","title":"Islands.Game.notify_player/2","doc":"Sends the game state to a player's process.","ref":"Islands.Game.html#notify_player/2"},{"type":"function","title":"Islands.Game.opponent_id/1","doc":"Returns a player's opponent ID.","ref":"Islands.Game.html#opponent_id/1"},{"type":"type","title":"Islands.Game.overview/0","doc":"A game overview map","ref":"Islands.Game.html#t:overview/0"},{"type":"function","title":"Islands.Game.overview/1","doc":"Returns the game overview map of `game`.","ref":"Islands.Game.html#overview/1"},{"type":"type","title":"Islands.Game.overview_player/0","doc":"A game overview player map","ref":"Islands.Game.html#t:overview_player/0"},{"type":"function","title":"Islands.Game.player_board/2","doc":"Returns a player's board struct.","ref":"Islands.Game.html#player_board/2"},{"type":"function","title":"Islands.Game.pop/2","doc":"Callback implementation for  Access.pop/2 .","ref":"Islands.Game.html#pop/2"},{"type":"function","title":"Islands.Game.random_name/0","doc":"Returns a random name of 4 to 10 characters.","ref":"Islands.Game.html#random_name/0"},{"type":"type","title":"Islands.Game.t/0","doc":"A game struct for the Game of Islands","ref":"Islands.Game.html#t:t/0"},{"type":"function","title":"Islands.Game.update_board/3","doc":"Updates a player's board struct with `board`.","ref":"Islands.Game.html#update_board/3"},{"type":"function","title":"Islands.Game.update_guesses/4","doc":"Updates a player's guesses struct using `hit_or_miss` and `guess`.","ref":"Islands.Game.html#update_guesses/4"},{"type":"function","title":"Islands.Game.update_player/5","doc":"Updates a player struct using `name`, `gender` and `pid`.","ref":"Islands.Game.html#update_player/5"},{"type":"function","title":"Islands.Game.update_request/2","doc":"Updates the request tuple.","ref":"Islands.Game.html#update_request/2"},{"type":"function","title":"Islands.Game.update_response/2","doc":"Updates the response tuple.","ref":"Islands.Game.html#update_response/2"},{"type":"function","title":"Islands.Game.update_state/2","doc":"Updates the state struct.","ref":"Islands.Game.html#update_state/2"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}